Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Node.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Node.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Node.h	(revision 12878)
@@ -0,0 +1,113 @@
+/*!\file Node.h
+ * \brief: header file for node object
+ */
+
+#ifndef _NODE_H_
+#define _NODE_H_
+
+/*Headers:*/
+/*{{{*/
+#include "./Object.h"
+#include "../../shared/shared.h"
+#include "../DofIndexing.h"
+class  Inputs;
+class  Hook;
+class  IoModel;
+class  DataSet;
+class  Vertices;
+class  Vector;
+class  Matrix;
+#include "../Update.h"
+/*}}}*/
+
+class Node: public Object ,public Update{
+
+	public: 
+
+		int	    id;  //unique arbitrary id.
+		int     sid; //sid for "serial" id, ie the rank of this node in the nodes dataset, if the dataset was serial on 1 cpu.
+				
+		DofIndexing    indexing;
+		Hook*          hvertex;
+		Inputs*        inputs; //properties of this node
+		int            analysis_type;
+		IssmDouble         coord_system[3][3];
+
+		/*Node constructors, destructors {{{*/
+		Node();
+		Node(int node_id,int node_sid, int vertex_id,int io_index, IoModel* iomodel,int analysis_type);
+		~Node();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy(){_error2_("Not implemented yet (similar to Elements)");};
+		/*}}}*/
+		/*Update virtual functions definitions: {{{*/
+		
+		void  InputUpdateFromVector(IssmDouble* vector, int name, int type);
+		void  InputUpdateFromVector(int* vector, int name, int type);
+		void  InputUpdateFromVector(bool* vector, int name, int type);
+		void  InputUpdateFromMatrixDakota(IssmDouble* matrix,int nrows, int ncols, int name, int type);
+		void  InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type);
+		void  InputUpdateFromVectorDakota(int* vector, int name, int type);
+		void  InputUpdateFromVectorDakota(bool* vector, int name, int type);
+		void  InputUpdateFromConstant(IssmDouble constant, int name);
+		void  InputUpdateFromConstant(int constant, int name);
+		void  InputUpdateFromConstant(bool constant, int name);
+		void  InputUpdateFromSolution(IssmDouble* solution){_error2_("Not implemented yet!");}
+		void  InputUpdateFromIoModel(int index, IoModel* iomodel){_error2_("Not implemented yet!");}
+		/*}}}*/
+		/*Node numerical routines {{{*/
+		void   Configure(DataSet* nodes,Vertices* vertices);
+		void   CreateNodalConstraints(Vector* ys);
+		void   SetCurrentConfiguration(DataSet* nodes,Vertices* vertices);
+		int    Sid(void); 
+		int    GetVertexDof(void);
+		int    GetVertexId(void);
+#ifdef _HAVE_DIAGNOSTIC_
+		void   GetCoordinateSystem(IssmDouble* coord_system_out);
+#endif
+		void   SetVertexDof(int in_dof);
+		bool   InAnalysis(int analysis_type);
+		int    GetApproximation();
+		int    GetNumberOfDofs(int approximation_enum,int setenum);
+		int    IsClone();
+		void   ApplyConstraint(int dof,IssmDouble value);
+		void   RelaxConstraint(int dof);
+		void   DofInSSet(int dof);
+		void   DofInFSet(int dof);
+		int    GetDof(int dofindex,int setenum);
+		void   CreateVecSets(Vector* pv_g,Vector* pv_f,Vector* pv_s);
+		int    GetConnectivity();
+		void   GetDofList(int* poutdoflist,int approximation_enum,int setenum);
+		void   GetLocalDofList(int* poutdoflist,int approximation_enum,int setenum);
+		int    GetDofList1(void);
+		int    GetSidList(void);
+		IssmDouble GetX();
+		IssmDouble GetY();
+		IssmDouble GetZ();
+		IssmDouble GetSigma();
+		int    IsOnBed();
+		int    IsOnSurface();
+		void   FreezeDof(int dof);
+		int    IsFloating();
+		int    IsGrounded();
+		void   UpdateSpcs(IssmDouble* ys);
+		void   VecMerge(Vector* ug, IssmDouble* vector_serial,int setenum);
+		void   VecReduce(Vector* vector, IssmDouble* ug_serial,int setnum);
+		
+		/*}}}*/
+		/*Dof Object routines {{{*/
+		void  DistributeDofs(int* pdofcount,int setenum);
+		void  OffsetDofs(int dofcount,int setenum);
+		void  ShowTrueDofs(int* truerows,int ncols,int setenum);
+		void  UpdateCloneDofs(int* alltruerows,int ncols,int setenum);
+		void  SetClone(int* minranks);
+		/*}}}*/
+};
+
+#endif  /* _NODE_H_ */
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Object.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Object.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Object.h	(revision 12878)
@@ -0,0 +1,27 @@
+/*
+ * Object.h:
+ * \brief prototype for abstract Object class
+ * \file Object.h
+ * This prototype describes the Object class. This is an abstract class, parent 
+ * to any other objects (Quad, Tria, Node , etc ...), that can be included in a 
+ * DataSet.
+ */
+
+
+#ifndef _OBJECT_H_
+#define _OBJECT_H_
+
+class Object {
+
+	public: 
+
+		virtual       ~Object() {};
+		virtual void  Echo()=0;
+		virtual void  DeepEcho()=0;
+		virtual int   Id()=0;
+		virtual int   MyRank()=0;
+		virtual int   ObjectEnum()=0;
+		virtual Object* copy()=0;
+
+};
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.cpp	(revision 12878)
@@ -0,0 +1,116 @@
+/*!\file Option.cpp
+ * \brief: implementation of the optionsobject abstract object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../io/io.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*Constructors/destructor/copy*/
+/*FUNCTION Option::Option(){{{*/
+Option::Option(){
+
+	name  =NULL;
+	numel =0;
+	ndims =0;
+	size  =NULL;
+
+}
+/*}}}*/
+/*FUNCTION Option::~Option(){{{*/
+Option::~Option(){
+
+	if(size) xDelete<int>(size);
+	if(name) xDelete<char>(name);
+
+}
+/*}}}*/
+
+/*Other*/
+/*FUNCTION Option::Echo {{{*/
+void  Option::Echo(){
+
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_("          name: \"" << name << "\"");
+	if(flag) _pprintLine_("         numel: " << numel);
+	if(flag) _pprintLine_("         ndims: " << ndims);
+	if(size){
+		StringFromSize(cstr,size,ndims);
+		if(flag) _pprintLine_("          size: " << cstr);
+	}
+	else if(flag) _pprintLine_("          size: [empty]");
+}
+/*}}}*/
+/*FUNCTION Option::DeepEcho() {{{*/
+void  Option::DeepEcho(){
+
+	char  indent[81]="";
+
+	Option::DeepEcho(indent);
+
+	return;
+}
+/*}}}*/
+/*FUNCTION Option::DeepEcho(char* indent) {{{*/
+void  Option::DeepEcho(char* indent){
+
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_(indent << "          name: \"" << name << "\"");
+	if(flag) _pprintLine_(indent << "         numel: " << numel);
+	if(flag) _pprintLine_(indent << "         ndims: " << ndims);
+	if(size){
+		StringFromSize(cstr,size,ndims);
+		if(flag) _pprintLine_(indent << "          size: " << cstr);
+	}
+	else if(flag) _pprintLine_(indent << "          size: [empty]");
+}
+/*}}}*/
+/*FUNCTION Option::Name {{{*/
+char* Option::Name(){
+
+	return(name);
+}
+/*}}}*/
+/*FUNCTION Option::NumEl {{{*/
+int   Option::NumEl(){
+
+	return(numel);
+}
+/*}}}*/
+/*FUNCTION Option::NDims {{{*/
+int   Option::NDims(){
+
+	return(ndims);
+}
+/*}}}*/
+/*FUNCTION Option::Size {{{*/
+int*  Option::Size(){
+
+	return(size);
+}
+/*}}}*/
+/*FUNCTION Option::Get {{{*/
+//void* Option::Get(){
+
+//	;
+
+//	return;
+//}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/Option.h	(revision 12878)
@@ -0,0 +1,55 @@
+/*! \file Option.h 
+ *  \brief: header file for option abstract object
+ */
+
+#ifndef _OPTIONOBJECT_H_
+#define _OPTIONOBJECT_H_
+
+/*Headers:{{{*/
+#include "../../../include/include.h"
+#include "../../../shared/Exceptions/exceptions.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+
+#include "../Object.h"
+/*}}}*/
+
+class Option: public Object {
+
+	public:
+
+		char* name;
+		int   numel;
+		int   ndims;
+		int*  size;
+
+		/*Option constructors, destructors {{{*/
+		Option();
+		~Option();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{*/
+		virtual void  Echo();
+		virtual void  DeepEcho();
+		virtual void  DeepEcho(char* indent);
+		int   Id(){_error2_("Not implemented yet");};
+		int   MyRank(){_error2_("Not implemented yet");};
+		int   ObjectEnum(){return OptionEnum;};
+		Object* copy(){_error2_("Not implemented yet");};
+		/*}}}*/
+
+		/*virtual functions: */
+		virtual char* Name()=0;
+		virtual int   NumEl()=0;
+		virtual int   NDims()=0;
+		virtual int*  Size()=0;
+		virtual void  Get(int* pvalue)=0;
+		virtual void  Get(IssmDouble* pvalue)=0;
+		virtual void  Get(bool* pvalue)=0;
+		virtual void  Get(char** pvalue)=0;
+		virtual void  Get(char*** ppvalue,int *pnumel)=0;
+		virtual void  Get(IssmDouble** pvalue,int *pnumel)=0;
+		virtual void  Get(Options** pvalue)=0;
+		virtual void  Get(Options*** ppvalue,int *pnumel)=0;
+
+};
+#endif  /* _OPTIONOBJECT_H */
+
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.cpp	(revision 12878)
@@ -0,0 +1,127 @@
+/*!\file OptionCell.cpp
+ * \brief: implementation of the optionscell object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../shared/shared.h"
+#include "../../../io/io.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*Constructors/destructor/copy*/
+/*FUNCTION OptionCell::OptionCell(){{{*/
+OptionCell::OptionCell(){
+
+	values    =NULL;
+
+}
+/*}}}*/
+/*FUNCTION OptionCell::~OptionCell(){{{*/
+OptionCell::~OptionCell(){
+
+	if (values){
+		delete values;
+		values    =NULL;
+	}
+
+}
+/*}}}*/
+
+/*Other*/
+/*FUNCTION OptionCell::Echo {{{*/
+void  OptionCell::Echo(){
+
+	char cstr[81];
+	bool flag     = true;
+
+	if(flag) _pprintLine_("OptionCell Echo:");
+	Option::Echo();
+
+	if (values && size) {
+		StringFromSize(cstr,size,ndims);
+		if(flag) _pprintLine_("        values: " << cstr << " " << "cell");
+	}
+	else if(flag) _pprintLine_("        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionCell::DeepEcho() {{{*/
+void  OptionCell::DeepEcho(){
+
+	char  indent[81]="";
+
+	OptionCell::DeepEcho(indent);
+
+	return;
+}
+/*}}}*/
+/*FUNCTION OptionCell::DeepEcho(char* indent) {{{*/
+void  OptionCell::DeepEcho(char* indent){
+
+	int   i;
+	int*  dims;
+	char  indent2[81];
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_(indent << "OptionCell DeepEcho:");
+	Option::DeepEcho(indent);
+
+	xMemCpy<char>(indent2,indent,(strlen(indent)+1));
+	strcat(indent2,"  ");
+
+	if (values->Size()) {
+		dims=xNew<int>(ndims);
+		for (i=0; i<values->Size(); i++) {
+			ColumnWiseDimsFromIndex(dims,i,size,ndims);
+			StringFromDims(cstr,dims,ndims);
+			if(flag) _pprintLine_(indent << "        values: -------- begin " << cstr << " --------");
+			((Option *)values->GetObjectByOffset(i))->DeepEcho(indent2);
+			if(flag) _pprintLine_(indent << "        values: --------  end  " << cstr << " --------");
+		}
+		xDelete<int>(dims);
+	}
+	else if(flag) _pprintLine_(indent << "        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionCell::Name {{{*/
+char* OptionCell::Name(){
+
+	return(Option::Name());
+}
+/*}}}*/
+/*FUNCTION OptionCell::NumEl {{{*/
+int   OptionCell::NumEl(){
+
+	return(Option::NumEl());
+}
+/*}}}*/
+/*FUNCTION OptionCell::NDims {{{*/
+int   OptionCell::NDims(){
+
+	return(Option::NDims());
+}
+/*}}}*/
+/*FUNCTION OptionCell::Size {{{*/
+int*  OptionCell::Size(){
+
+	return(Option::Size());
+}
+/*}}}*/
+/*FUNCTION OptionCell::Get(Options** pvalue) {{{*/
+void OptionCell::Get(Options** pvalue){
+
+	/*Assign output pointer*/
+	*pvalue=this->values;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionCell.h	(revision 12878)
@@ -0,0 +1,52 @@
+/*! \file OptionCell.h 
+ *  \brief: header file for optioncell object
+ */
+
+#ifndef _OPTIONCELL_H_
+#define _OPTIONCELL_H_
+
+/*Headers:{{{*/
+#include "../../../include/include.h"
+#include "../../../shared/Exceptions/exceptions.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+
+#include "./Option.h"
+/*}}}*/
+
+class OptionCell: public Option {
+
+	public:
+
+		Options* values;
+
+		/*OptionCell constructors, destructors {{{*/
+		OptionCell();
+		~OptionCell();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{*/
+		void  Echo();
+		void  DeepEcho();
+		void  DeepEcho(char* indent);
+		int   Id(){_error2_("Not implemented yet");};
+		int   MyRank(){_error2_("Not implemented yet");};
+		int   ObjectEnum(){return OptionCellEnum;};
+		Object* copy(){_error2_("Not implemented yet");};
+		/*}}}*/
+
+		/*virtual functions: */
+		char* Name();
+		int   NumEl();
+		int   NDims();
+		int*  Size();
+		void  Get(int* pvalue){_error2_("An OptionCell object cannot return a int");};
+		void  Get(IssmDouble* pvalue){_error2_("An OptionCell object cannot return a IssmDouble");};
+		void  Get(bool* pvalue){  _error2_("An OptionCell object cannot return a bool");};
+		void  Get(char** pvalue){ _error2_("An OptionCell object cannot return a string");};
+		void  Get(char*** ppvalue,int *pnumel){ _error2_("An OptionCell object cannot return a string vec");};
+		void  Get(IssmDouble** pvalue,int *pnumel){ _error2_("An OptionCell object cannot return a IssmDouble vec");};
+		void  Get(Options** pvalue);
+		void  Get(Options*** ppvalue,int *pnumel){ _error2_("An OptionCell object cannot return an Options DataSet vec");};
+
+};
+#endif  /* _OPTIONCELL_H */
+
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.cpp	(revision 12878)
@@ -0,0 +1,176 @@
+/*!\file OptionChar.cpp
+ * \brief: implementation of the optionschar object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../shared/shared.h"
+#include "../../../io/io.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*Constructors/destructor/copy*/
+/*FUNCTION OptionChar::OptionChar(){{{*/
+OptionChar::OptionChar(){
+
+	values    =NULL;
+
+}
+/*}}}*/
+/*FUNCTION OptionChar::~OptionChar(){{{*/
+OptionChar::~OptionChar(){
+
+	if (values) xDelete<char>(values);
+
+}
+/*}}}*/
+
+/*Other*/
+/*FUNCTION OptionChar::Echo {{{*/
+void  OptionChar::Echo(){
+
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_("OptionChar Echo:");
+	Option::Echo();
+
+	if (values && size) {
+//		if (numel == 1) {
+		if (1) {
+//			if(flag) _pprintLine_("        values: \"" << values[0] << "\"");
+			if(flag) _pprintLine_("        values: \"" << values << "\"");
+		}
+		else {
+			StringFromSize(cstr,size,ndims);
+			if(flag) _pprintLine_("        values: " << cstr << " " << "char");
+		}
+	}
+	else if(flag) _pprintLine_("        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionChar::DeepEcho() {{{*/
+void  OptionChar::DeepEcho(){
+
+	char  indent[81]="";
+
+	OptionChar::DeepEcho(indent);
+
+	return;
+}
+/*}}}*/
+/*FUNCTION OptionChar::DeepEcho(char* indent) {{{*/
+void  OptionChar::DeepEcho(char* indent){
+
+	int   i,nstr,ipt=0;
+	int*  dims;
+	char  indent2[81];
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_(indent << "OptionChar DeepEcho:");
+	Option::DeepEcho(indent);
+
+	xMemCpy<char>(indent2,indent,(strlen(indent)+1));
+	strcat(indent2,"  ");
+
+	if (values) {
+		if (ndims == 2 && size[0] == 1) {
+			if(flag) _pprintLine_(indent << "        values: \"" << values << "\"");
+		}
+		else {
+			nstr=size[0];
+			for (i=2; i<ndims; i++) nstr*=size[i];
+
+			dims=xNew<int>(ndims);
+			for (i=0; i<nstr; i++) {
+				RowWiseDimsFromIndex(dims,ipt,size,ndims);
+				StringFromDims(cstr,dims,ndims);
+				if(flag) _pprintLine_(indent << "        values" << cstr << ": \"" << size[1] << "*s\"");
+				ipt+=size[1];
+			}
+			xDelete<int>(dims);
+		}
+	}
+	else if(flag) _pprintLine_(indent << "        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionChar::Name {{{*/
+char* OptionChar::Name(){
+
+	return(Option::Name());
+}
+/*}}}*/
+/*FUNCTION OptionChar::NumEl {{{*/
+int   OptionChar::NumEl(){
+
+	return(Option::NumEl());
+}
+/*}}}*/
+/*FUNCTION OptionChar::NDims {{{*/
+int   OptionChar::NDims(){
+
+	return(Option::NDims());
+}
+/*}}}*/
+/*FUNCTION OptionChar::Size {{{*/
+int*  OptionChar::Size(){
+
+	return(Option::Size());
+}
+/*}}}*/
+/*FUNCTION OptionChar::Get(char** pvalue) {{{*/
+void OptionChar::Get(char** pvalue){
+
+	char* outstring=NULL;
+	int   stringsize;
+
+	stringsize=strlen(this->values)+1;
+
+	outstring=xNew<char>(stringsize);
+	xMemCpy<char>(outstring,this->values,stringsize);
+
+	*pvalue=outstring;
+}
+/*}}}*/
+/*FUNCTION OptionChar::Get(char*** ppvalue,int *pnumel) {{{*/
+void OptionChar::Get(char*** ppvalue,int *pnumel){
+
+	char* outstring=NULL;
+	int   stringsize;
+	int   i,nstr,ipt=0;
+
+	/*We should first check that the size is at least one*/
+	if(this->NumEl()<=0){
+		_error2_("option \"" << this->name << "\" is empty and cannot return a string vector");
+	}
+
+	/*Calculate the size and number of strings*/
+	stringsize=this->size[1]+1;
+	nstr=this->size[0];
+	for (i=2; i<this->ndims; i++) nstr*=this->size[i];
+
+	/*Break concatenated string into individual strings*/
+	*ppvalue=xNew<char*>(nstr);
+	for (i=0; i<nstr; i++) {
+		outstring=xNew<char>(stringsize);
+		xMemCpy<char>(outstring,&(this->values[ipt]),(stringsize-1));
+		outstring[stringsize-1]='\0';
+		(*ppvalue)[i]=outstring;
+		ipt+=stringsize-1;
+	}
+
+	/*Assign output pointer*/
+	if(numel) *pnumel=nstr;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionChar.h	(revision 12878)
@@ -0,0 +1,52 @@
+/*! \file OptionChar.h 
+ *  \brief: header file for optionchar object
+ */
+
+#ifndef _OPTIONCHAR_H_
+#define _OPTIONCHAR_H_
+
+/*Headers:{{{*/
+#include "../../../include/include.h"
+#include "../../../shared/Exceptions/exceptions.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+
+#include "./Option.h"
+/*}}}*/
+
+class OptionChar: public Option {
+
+	public:
+
+		char* values;
+
+		/*OptionChar constructors, destructors {{{*/
+		OptionChar();
+		~OptionChar();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{*/
+		void  Echo();
+		void  DeepEcho();
+		void  DeepEcho(char* indent);
+		int   Id(){_error2_("Not implemented yet");};
+		int   MyRank(){_error2_("Not implemented yet");};
+		int   ObjectEnum(){return OptionCharEnum;};
+		Object* copy(){_error2_("Not implemented yet");};
+		/*}}}*/
+
+		/*virtual functions: */
+		char* Name();
+		int   NumEl();
+		int   NDims();
+		int*  Size();
+		void  Get(int* pvalue){_error2_("An OptionChar object cannot return a int");};
+		void  Get(IssmDouble* pvalue){_error2_("An OptionChar object cannot return a IssmDouble");};
+		void  Get(bool* pvalue){  _error2_("An OptionChar object cannot return a bool");};
+		void  Get(char** pvalue);
+		void  Get(char*** ppvalue,int *pnumel);
+		void  Get(IssmDouble** pvalue,int *pnumel){ _error2_("An OptionChar object cannot return a IssmDouble vec");};
+		void  Get(Options** pvalue){ _error2_("An OptionChar object cannot return an Options DataSet");};
+		void  Get(Options*** ppvalue,int *pnumel){ _error2_("An OptionChar object cannot return an Options DataSet vec");};
+
+};
+#endif  /* _OPTIONCHAR_H */
+
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.cpp	(revision 12878)
@@ -0,0 +1,162 @@
+/*!\file OptionDouble.cpp
+ * \brief: implementation of the optionsIssmDouble object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../shared/shared.h"
+#include "../../../io/io.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*Constructors/destructor/copy*/
+/*FUNCTION OptionDouble::OptionDouble(){{{*/
+OptionDouble::OptionDouble(){
+
+	values    =NULL;
+
+}
+/*}}}*/
+/*FUNCTION OptionDouble::~OptionDouble(){{{*/
+OptionDouble::~OptionDouble(){
+
+	if (values) xDelete<IssmDouble>(values);
+
+}
+/*}}}*/
+
+/*Other*/
+/*FUNCTION OptionDouble::Echo {{{*/
+void  OptionDouble::Echo(){
+
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_("OptionDouble Echo:");
+	Option::Echo();
+
+	if (values && size) {
+		if(numel == 1) if(flag) _pprintLine_("        values: " << values[0]);
+		else {
+			StringFromSize(cstr,size,ndims);
+			if(flag) _pprintLine_("        values: " << cstr << " " << "IssmDouble");
+		}
+	}
+	else if(flag) _pprintLine_("        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionDouble::DeepEcho() {{{*/
+void  OptionDouble::DeepEcho(){
+
+	char  indent[81]="";
+
+	OptionDouble::DeepEcho(indent);
+
+	return;
+}
+/*}}}*/
+/*FUNCTION OptionDouble::DeepEcho(char* indent) {{{*/
+void  OptionDouble::DeepEcho(char* indent){
+
+	int   i;
+	int*  dims;
+	char  indent2[81];
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_(indent << "OptionDouble DeepEcho:");
+	Option::DeepEcho(indent);
+
+	xMemCpy<char>(indent2,indent,(strlen(indent)+1));
+	strcat(indent2,"  ");
+
+	if (values) {
+		dims=xNew<int>(ndims);
+		if(numel==1) if(flag) _pprintLine_(indent << "        values: " << values[0]);
+		else{
+			for (i=0; i<numel; i++) {
+				RowWiseDimsFromIndex(dims,i,size,ndims);
+				StringFromDims(cstr,dims,ndims);
+				if(flag) _pprintLine_(indent << "        values" << cstr << ": " << values[i]);
+			}
+		}
+		xDelete<int>(dims);
+	}
+	else if(flag) _pprintLine_(indent << "        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionDouble::Name {{{*/
+char* OptionDouble::Name(){
+
+	return(Option::Name());
+}
+/*}}}*/
+/*FUNCTION OptionDouble::NumEl {{{*/
+int   OptionDouble::NumEl(){
+
+	return(Option::NumEl());
+}
+/*}}}*/
+/*FUNCTION OptionDouble::NDims {{{*/
+int   OptionDouble::NDims(){
+
+	return(Option::NDims());
+}
+/*}}}*/
+/*FUNCTION OptionDouble::Size {{{*/
+int*  OptionDouble::Size(){
+
+	return(Option::Size());
+}
+/*}}}*/
+/*FUNCTION OptionDouble::Get(int* pvalue) {{{*/
+void OptionDouble::Get(int* pvalue){
+
+	/*We should first check that the size is one*/
+	if(this->NumEl()!=1){
+		_error2_("option \"" << this->name << "\" has " << this->NumEl() << " elements and cannot return a single int");
+	}
+
+	/*Assign output pointer*/
+	*pvalue=reCast<int>(values[0]);
+}
+/*}}}*/
+/*FUNCTION OptionDouble::Get(IssmDouble* pvalue) {{{*/
+void OptionDouble::Get(IssmDouble* pvalue){
+
+	/*We should first check that the size is one*/
+	if(this->NumEl()!=1){
+		_error2_("option \"" << this->name << "\" has " << this->NumEl() << " elements and cannot return a single IssmDouble");
+	}
+
+	/*Assign output pointer*/
+	*pvalue=this->values[0];
+}
+/*}}}*/
+/*FUNCTION OptionDouble::Get(IssmDouble** pvalue,int* numel) {{{*/
+void OptionDouble::Get(IssmDouble** pvalue,int* numel){
+
+	/*We should first check that the size is at least one*/
+	if(this->NumEl()<=0){
+		_error2_("option \"" << this->name << "\" is empty and cannot return a IssmDouble vector");
+	}
+
+	/*Copy vector*/
+	IssmDouble* outvalue=xNew<IssmDouble>(this->NumEl());
+	for(int i=0;i<this->NumEl();i++) outvalue[i]=this->values[i];
+
+	/*Assign output pointer*/
+	*pvalue=outvalue;
+	if(numel) *numel=this->NumEl();
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionDouble.h	(revision 12878)
@@ -0,0 +1,52 @@
+/*! \file OptionDouble.h 
+ *  \brief: header file for optionIssmDouble object
+ */
+
+#ifndef _OPTIONDOUBLE_H_
+#define _OPTIONDOUBLE_H_
+
+/*Headers:{{{*/
+#include "../../../include/include.h"
+#include "../../../shared/Exceptions/exceptions.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+
+#include "./Option.h"
+/*}}}*/
+
+class OptionDouble: public Option {
+
+	public:
+
+		IssmDouble* values;
+
+		/*OptionDouble constructors, destructors {{{*/
+		OptionDouble();
+		~OptionDouble();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{*/
+		void  Echo();
+		void  DeepEcho();
+		void  DeepEcho(char* indent);
+		int   Id(){_error2_("Not implemented yet");};
+		int   MyRank(){_error2_("Not implemented yet");};
+		int   ObjectEnum(){return OptionDoubleEnum;};
+		Object* copy(){_error2_("Not implemented yet");};
+		/*}}}*/
+
+		/*virtual functions: */
+		char* Name();
+		int   NumEl();
+		int   NDims();
+		int*  Size();
+		void  Get(int* pvalue);
+		void  Get(IssmDouble* pvalue);
+		void  Get(bool* pvalue){  _error2_("An OptionDouble object cannot return a bool");};
+		void  Get(char** pvalue){ _error2_("An OptionDouble object cannot return a string");};
+		void  Get(char*** ppvalue,int *pnumel){ _error2_("An OptionDouble object cannot return a string vec");};
+		void  Get(IssmDouble** pvalue,int* pnumel);
+		void  Get(Options** pvalue){ _error2_("An OptionDouble object cannot return an Options DataSet");};
+		void  Get(Options*** ppvalue,int *pnumel){ _error2_("An OptionDouble object cannot return an Options DataSet vec");};
+
+};
+#endif  /* _OPTIONDOUBLE_H */
+
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionLogical.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionLogical.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/Options/OptionLogical.cpp	(revision 12878)
@@ -0,0 +1,133 @@
+/*!\file OptionLogical.cpp
+ * \brief: implementation of the optionslogical object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../shared/shared.h"
+#include "../../../io/io.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*Constructors/destructor/copy*/
+/*FUNCTION OptionLogical::OptionLogical(){{{*/
+OptionLogical::OptionLogical(){
+
+	values    =NULL;
+
+}
+/*}}}*/
+/*FUNCTION OptionLogical::~OptionLogical(){{{*/
+OptionLogical::~OptionLogical(){
+
+	if (values) xDelete<bool>(values);
+
+}
+/*}}}*/
+
+/*Other*/
+/*FUNCTION OptionLogical::Echo {{{*/
+void  OptionLogical::Echo(){
+
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_("OptionLogical Echo:");
+	Option::Echo();
+
+	if (values && size) {
+		if(numel == 1) if(flag) _pprintLine_("        values: " << (values[0] ? "true" : "false"));
+		else{
+			StringFromSize(cstr,size,ndims);
+			if(flag) _pprintLine_("        values: " << cstr << " " << "logical");
+		}
+	}
+	else if(flag) _pprintLine_("        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionLogical::DeepEcho() {{{*/
+void  OptionLogical::DeepEcho(){
+
+	char  indent[81]="";
+
+	OptionLogical::DeepEcho(indent);
+
+	return;
+}
+/*}}}*/
+/*FUNCTION OptionLogical::DeepEcho(char* indent) {{{*/
+void  OptionLogical::DeepEcho(char* indent){
+
+	int   i;
+	int*  dims;
+	char  indent2[81];
+	char  cstr[81];
+	bool  flag=true;
+
+	if(flag) _pprintLine_(indent << "OptionLogical DeepEcho:");
+	Option::DeepEcho(indent);
+
+	xMemCpy<char>(indent2,indent,(strlen(indent)+1));
+	strcat(indent2,"  ");
+
+	if (values) {
+		if(numel==1) if(flag) _pprintLine_(indent << "        values: " << (values[0] ? "true" : "false"));
+		else{
+			dims=xNew<int>(ndims);
+			for (i=0; i<numel; i++) {
+				RowWiseDimsFromIndex(dims,i,size,ndims);
+				StringFromDims(cstr,dims,ndims);
+				if(flag) _pprintLine_(indent << "        values" << cstr << ": " << (values[i] ? "true" : "false"));
+			}
+			xDelete<int>(dims);
+		}
+	}
+	else if(flag) _pprintLine_(indent << "        values: [empty]");
+}
+/*}}}*/
+/*FUNCTION OptionLogical::Name {{{*/
+char* OptionLogical::Name(){
+
+	return(Option::Name());
+}
+/*}}}*/
+/*FUNCTION OptionLogical::NumEl {{{*/
+int   OptionLogical::NumEl(){
+
+	return(Option::NumEl());
+}
+/*}}}*/
+/*FUNCTION OptionLogical::NDims {{{*/
+int   OptionLogical::NDims(){
+
+	return(Option::NDims());
+}
+/*}}}*/
+/*FUNCTION OptionLogical::Size {{{*/
+int*  OptionLogical::Size(){
+
+	return(Option::Size());
+}
+/*}}}*/
+/*FUNCTION OptionLogical::Get(bool* pvalue) {{{*/
+void OptionLogical::Get(bool* pvalue){
+
+	/*We should first check that the size is one*/
+	if(this->NumEl()!=1){
+		_error2_("option \"" << this->name << "\" has " << this->NumEl() << " elements and cannot return a single bool");
+	}
+
+	/*Assign output pointer*/
+	*pvalue=this->values[0];
+}
+/*}}}*/
